/*
 * Demonstrating Buffer Overflows
 *
 * Examples presented at the Grazer Linuxtage 2004
 *
 * Copyright (C) 2004 Thomas Winkler <tom@qwws.net>
 * Copyright (C) 2004 Markus Quaritsch <quam@qwws.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


/*
 * This example demonstrates how parameters are passed to a function using the
 * stack. Also have a look at the assembler file generated by gcc (example1.s)
 *
 * When you look at the prelude of the function you can also see how local
 * variables are placed on the stack. The stackpointer gets decremented, buffer1
 * and buffer2 are addressed by offsets to the basepointer
 */
void function(int a, int b, int c) {
	char buffer1[5];
	char buffer2[10];
}

int main() {

	function(1, 2, 3);

	return 0;
}
