/*
 * Demonstrating Buffer Overflows
 *
 * Examples presented at the Grazer Linuxtage 2004
 *
 * Copyright (C) 2004 Thomas Winkler <tom@qwws.net>
 * Copyright (C) 2004 Markus Quaritsch <quam@qwws.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


/* 
 * This example demonstrates how easy it is to overflow a buffer which results
 * in a segmentation fault.
 *
 * In the main-function we allocate a large buffer (256 bytes) and fill this
 * buffer with the character 'A'. This string gets passed to the function which
 * copies the large string over a much smaller one and thereby overwrites the
 * return address. When the function returns, the return address points to an
 * address which does not belong to the process and therefore produces a
 * segmentation fault.
 */
void function(char *str) {
	char buffer[16];

	strcpy(buffer, str);
}

int main() {
	char large_string[256];
	int i;
	
	for (i = 0; i < 255; i++) 
		large_string[i] = 'A';

	function(large_string);
}
